
/* this is an architecture-dependent function now. There are too many
 * motherboard differences
 */
/* ===========================================================================
 * Fill the input buffer. This is called only when the buffer is empty
 * and at least one byte is really needed.
 */
int firstfill;
int fill_inbuf()
{
  extern unsigned char *inbuf;
  extern unsigned int insize;
  extern unsigned int inptr;
/* boy, nvram is really slow. So malloc a 1M chunk and bcopy the relevant
 * junk out to it.
 */
#define K64 (64 * 1024)
   unsigned char *nvram, *ram;
   extern char * malloc();
   /* just go ahead and allocate a meg */
   ram = malloc(K64 * 16);
   if (! ram) {
      error("ram malloc failed\n");
   } else if (! firstfill) {
      error("Error! fill_inbuf called twice!\n");
   } else {
     /* the way we do this makes inbuf and insize insensitive to
      * where we start in the nvram
      */
     /* for now, we're not using the last 64k seg of nvram. fix me. */
     inbuf = ram;
     insize = 0;
     for(insize = 0,nvram = (unsigned char  *)0xfff40000;
         nvram < (unsigned char *) 0xffff0000; nvram += K64) {
       if ((nvram == (unsigned char  *) 0xfff50000) ||
           (nvram == (unsigned char  *) 0xfff80000) ||
           (nvram == (unsigned char  *) 0xfffe0000))
         continue;
       memcpy(ram, nvram, K64);
       /* don't make a mistake and put these in the for. They have to be
        * here. See the continue
        */
       ram += K64;
       insize += K64;
     }
   }
  display("fill inbuf for all 1m to "); printint((unsigned int) inbuf);
  display("\n");
   inptr = 1;
   return inbuf[0];
}


