/* these are callbx-style functions you can call as subroutines. 
 * return address MUST BE in bx
 */
/* the register to write is in eax, return value is in al. */
cs_readbBX: 
                 orl  $0x80000000,%eax ; 
                 and  $0xfc,%al            /* clear bits 1-0 */ ; 
                 mov  $0xcf8,%dx           /* port 0xcf8 ?*/ ; 
                 outl  %eax,%dx             /* open up CS config */ ; 
                 add  $0x4,%dl             /* 0xcfc data port 0 */ ; 
                 mov  which,%al ; 
                 and  $0x3,%al             /* only bits 1-0 */ ; 
                 add  %al,%dl ; 
                 inb   %dx,%al              /* read  */ ; 
		 jmp %ebx


/* for the write case, the register is in %cl */
cs_writebBX: 
                 mov  $0x80000000,%eax       /* 32bit word with bit 31 set */ ; 
                 mov  which,%ax             /* put the reg# in the low part */ ; 
                 and  $0xfc,%al             /* dword align the reg# */ ; 
                 mov  $0xcf8,%dx            /* enable port  */ ; 
                 outl  %eax,%dx ; 
                 add  $0x4,%dl             /* 1st data port */ ; 
                 mov  which,%ax             /* register# */ ; 
                 and  $0x3,%ax ; 
                 add  %al,%dl ; 
                 mov  data, %al ; 
                 outb  %al,%dx                /* write to reg */
		 jmp %ebx

